//+------------------------------------------------------------------+
//|                                                           V2.mq4 |
//|                        Copyright 2020, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2020, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict


input double TakeProfit    =0;
input double MaxSpread     =1;
input double MaxProfit     =1;
input double Lots          =0.01;
input double TrailingStop  =30;
input double MACDOpenLevel =3;
input double MACDCloseLevel=2;
input double MaxOrderProfit=2;
input double MaxOrderLoss  =1;
input int    MATrendPeriod =26;
input int    MaxOrders     = 1;
input int    Slip          = 3;
extern int   FastEMA       =12;
extern int   SlowEMA       =26;
extern int   MACDSMA       =9;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+

int BuyFunction (int total,int ticketA)
  {
          int ticketB;
          double InitialEquity = AccountEquity();
      
        total=OrdersTotal();
        ticketA=OrderSend(Symbol(),OP_BUY,Lots,Ask,Slip,0,0,NULL,12895,0,Blue);
      
      for(int j=OrdersTotal()-1;j>=0;j--)
      {
        bool Select = OrderSelect(j,SELECT_BY_POS);  
        if (Select == true)
        
         {
           if     (OrderProfit()>=MaxOrderProfit)
           {
            bool Closing = OrderClose(OrderTicket(),OrderLots(),Ask,Slip,Blue);            
            if (Closing == true)
            int b = SellFunction (total,ticketB);
           }
           else if (OrderProfit()<= 0-MaxOrderLoss)
           {
            bool Closing = OrderClose(OrderTicket(),OrderLots(),Ask,Slip,Blue);
            if (Closing == true)
            int b = SellFunction (total,ticketB);
           }
           else if (AccountEquity()-InitialEquity >= MaxProfit)  //Please check, understand and confirm this statement
           {
                      int i;
                      bool result = false;

                      while(OrdersTotal()>0)
                       {
                        // Close open positions first to lock in profit/loss
                         for(i=OrdersTotal()-1;i>=0;i--)
                           {
                           if(OrderSelect(i, SELECT_BY_POS)==false) continue;

                            result = false;
                           if ( OrderType() == OP_BUY)  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), Slip, Red );
                           if ( OrderType() == OP_SELL)  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), Slip, Red );
                          
                           }
                       }
                      Print ("Account Profit Reached. All Open Trades Have Been Closed");
                  }
               
           } 
           else
           Print ("Error ", GetLastError(), " occurred selecting order");      
  
      }
  return(0);
 }
int SellFunction (int total,int ticketB)
  {
              int ticketA;
              double InitialEquity = AccountEquity();
              
              total = OrdersTotal();
              ticketB = OrderSend(Symbol(),OP_SELL,Lots,Bid,Slip,0,0,NULL,12895,0,Red);
       
       for(int j=OrdersTotal()-1;j>=0;j--)
       {
        bool Select = OrderSelect(j,SELECT_BY_POS);
        if (Select == true)
              
                 {
                  if     (OrderProfit()>= MaxOrderProfit)
                    {
                     bool Closing = OrderClose(OrderTicket(),OrderLots(),Bid,Slip,Red);
                     if (Closing == true)
                     int a = BuyFunction (total,ticketA);
                    }
                  else if     (OrderProfit() <= 0-MaxOrderLoss)
                  {
                  bool Closing = OrderClose(OrderTicket(),OrderLots(),Bid,Slip,Red);
                  if (Closing == true)
                  int a = BuyFunction (total,ticketA);
                  }
                  else if (AccountEquity()-InitialEquity >= MaxProfit)  //Please check, understand and confirm this statement
                  {
                      int i;
                      bool result = false;

                      while(OrdersTotal()>0)
                       {
                        // Close open positions first to lock in profit/loss
                         for(i=OrdersTotal()-1;i>=0;i--)
                           {
                           if(OrderSelect(i, SELECT_BY_POS)==false) continue;

                            result = false;
                           if ( OrderType() == OP_BUY)  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), Slip, Red );
                           if ( OrderType() == OP_SELL)  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), Slip, Red );
                          
                           }
                       }
                      Print ("Account Profit Reached. All Open Trades Have Been Closed");
                  }
               
              }
              else
              Print ("Error ",GetLastError()," occured when selecting order");
       }
             
       return(0);
   }       
            
  

int OnInit()
  {
//---
   
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   
  }
  

//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
   int total,ticketA,ticketB;
   int limit=1;
   double Spread = Ask - Bid;
   total=OrdersTotal();
   if((total<MaxOrders) && (Spread <= MaxSpread))
   {
   for(int i=1;i<=limit;i++)
    {
      double MAC1=iMACD(NULL,0,FastEMA,SlowEMA,MACDSMA,PRICE_CLOSE,MODE_MAIN,i);
      double MAC2=iMACD(NULL,0,FastEMA,SlowEMA,MACDSMA,PRICE_CLOSE,MODE_MAIN,i+1);
      double MAC3=iMACD(NULL,0,FastEMA,SlowEMA,MACDSMA,PRICE_CLOSE,MODE_MAIN,i+2);

      if(MAC1>0&&MAC2<0&&MAC3<0)
       {
        int x = BuyFunction (total,ticketA);
       }
      else if (MAC1<0&&MAC2>0&&MAC3>0)
       {
       int y = SellFunction (total,ticketB);
       }
      
     }
   }
   
      return;            
     
   }

   
      

//+------------------------------------------------------------------+
